/*
 * @author  Giuseppe Stanghellini @ ismar dot cnr dot it
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

import java.math.BigInteger;

/**
 *
 * @author  gstanghe
 */
public class Citizen implements Cloneable {
    public Parameters params;
    public double valoreFITNESS;
    int id_citizen;
    
    /** Creates a new instance of Individuo */
    public Citizen(ParameterSetup ps, int _id_citizen) 
    {
        id_citizen = _id_citizen;
        params = new Parameters(ps, id_citizen);
    }

    public void setId(int _id)
    {
        id_citizen = _id;
        params.setId(id_citizen);
    }
    
    public Object clone()
    {
        Citizen _c;
        try
        {
            _c = (Citizen)super.clone();
            _c.params = (Parameters)params.clone();
        }
	catch(Exception e){ _c = null; }
	return _c;
    }

    // This is the father, generate a son with mother splitting at bit_pos.
    public Citizen generate(Citizen mother, long bit_pos)
    {
        Citizen son = new Citizen(params.ps, -1);
        
        int i_param = (int)(bit_pos / params.ps.num_bits);
        int i_byte = (int)((bit_pos % params.ps.num_bits) / 8);
        int i_bit = (int)(bit_pos - i_param * params.ps.num_bits - 8 * i_byte);
        
        // First n parameters
        for(int i = 0; i < i_param; i++)
        {
            son.params.param[i] = (Parameter)params.param[i].clone();
        }

        // Parameter to break
        // First n bytes
        for(int i = 0; i < i_byte; i++)
        {
            son.params.param[i_param].bits[i] = params.param[i_param].bits[i];
        }
        
        // Byte to break
        int _mask = 1;
        _mask = _mask << i_bit;
        _mask -= 1;
        
        son.params.param[i_param].bits[i_byte] = (byte)(params.param[i_param].bits[i_byte] & _mask);
        son.params.param[i_param].bits[i_byte] |= mother.params.param[i_param].bits[i_byte] & ~_mask;
        
        // Last n bytes
        for(int i = i_byte + 1; i < params.ps.num_bytes; i++)
        {
            son.params.param[i_param].bits[i] = mother.params.param[i_param].bits[i];
        }

        // Last n parameters
        for(int i = i_param + 1; i < params.ps.num_params; i++)
        {
            son.params.param[i] = (Parameter)mother.params.param[i].clone();
        }
        
        // TODO
        return son;
    }
}
