/*
 * @author  Giuseppe Stanghellini @ ismar dot cnr dot it
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

import javax.swing.JTextArea;
import org.geo.misc.XYGraphPanel;

/**
 *
 * @author  gstanghe
 */
public class DataSet {
    
    int num_punti;
    double [] x, y, expected_y;
    double min_x, max_x, min_y, max_y;
    
    /** Creates a new instance of DataSet */
    public DataSet() 
    {
        num_punti = 0;
        x = new double[10000];
        y = new double[10000];
        expected_y = new double[10000];
    }
    
    /** 
     * @param xygp 
     */
    public void display(XYGraphPanel xygp, int layer)
    {
        xygp.reset(layer);
        xygp.reset(layer + 1);
        
        int i;
        
        for(i = 0; i < num_punti; i++)
        {
            xygp.addPoint(layer, x[i], y[i]);
            xygp.addPoint(layer + 1, x[i], expected_y[i]);
        }
        
        xygp.paint(xygp.getGraphics());
    }
    
    public void adjustMinMaxValues()
    {
        boolean first = true;
        for(int i = 0; i < num_punti; i++)
        {
            if(!first)
            {
                if(min_x > x[i]) min_x = x[i];
                if(min_y > y[i]) min_y = y[i];
                if(max_x < x[i]) max_x = x[i];
                if(max_y < y[i]) max_y = y[i];
            }
            else
            {
                min_x = y[i]; max_x = y[i];
                min_y = y[i]; max_y = y[i];
                first = false;
            }
        }
    }
    
    public void initializeDataset(JTextArea jta)
    {
        String t = jta.getText();
        String [] row = t.split("\n");
        for(int i = 0; i < java.lang.reflect.Array.getLength(row); i++)
        {
            String [] xy = row[i].split(" ");
            if(java.lang.reflect.Array.getLength(xy) == 2)
            {
                x[num_punti] = Double.valueOf(xy[0]).doubleValue();
                y[num_punti] = Double.valueOf(xy[1]).doubleValue();
                expected_y[num_punti] = y[num_punti];
                num_punti++;
            }
        }
        adjustMinMaxValues();
    }
    /***************************************************************************
    *                           FUNZIONE DI FITNESS
    ***************************************************************************/
    public void calcFITNESS(Citizen citizen, FittingFunction ff)
    {
        int i,j;
        double err;
        double dist_min, dist;
        err = 0;
        citizen.valoreFITNESS = 0;
   
        for(i = 0; i < num_punti; i++)
        {
            expected_y[i] = ff.evaluate(x[i], citizen.params);
            err = y[i] - expected_y[i];
            citizen.valoreFITNESS += err * err;
        }
    }
}
